app.factory("categoriesFactory", function($http){

    var factory = {};

    // read categories with paging
    factory.readCategories = function(json_url){

        // if json url is empty, use default
        json_url = json_url==""
                    ? "http://localhost/api/category/read_paging.php"
                    : json_url;

        return $http({
            method: 'GET',
            url: json_url
        });
    };

    // read all categories without paging
    factory.readAllCategories = function(){

        return $http({
            method: 'GET',
            url: "http://localhost/api/category/read.php"
        });
    };

    // create category
    factory.createCategory = function($scope){
        return $http({
            method: 'POST',
            data: {
                'name' : $scope.name,
                'description' : $scope.description,
                'price' : $scope.price,
                'category_id' : 1
            },
            url: 'http://localhost/api/category/create.php'
        });
    };

    // read one category
    factory.readOneCategory = function(id){
        return $http({
			method: 'GET',
			url: 'http://localhost/api/category/read_one.php?id=' + id
		});
    };

    // update category
    factory.updateCategory = function($scope){

        return $http({
			method: 'POST',
			data: {
				'id' : $scope.id,
				'name' : $scope.name,
				'description' : $scope.description,
				'price' : $scope.price,
				'category_id' : 1
			},
			url: 'http://localhost/api/category/update.php'
		});
    };

    // delete category
    factory.deleteCategory = function(id){
        return $http({
			method: 'POST',
			data: { 'id' : id },
			url: 'http://localhost/api/category/delete.php'
		});
    };

    // search all categories
    factory.searchCategories = function(json_url, keywords){

        // if json url is empty, use default
        json_url = json_url==""
                    ? "http://localhost/api/category/search_paging.php?s=" + keywords
                    : json_url;

        return $http({
            method: 'GET',
            url: json_url
        });
    };

    return factory;
});
